<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Player Dismissal Count</title>
    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="https://code.highcharts.com/modules/exporting.js"></script>
    <script src="https://code.highcharts.com/modules/export-data.js"></script>
    <script src="https://code.highcharts.com/modules/accessibility.js"></script>
    <style>
      .highcharts-figure,
      .highcharts-data-table table {
        min-width: 500px;
        max-width: 800px;
        margin: 1em auto;
      }

      #container {
        height: 400px;
      }

      .highcharts-data-table table {
        font-family: Verdana, sans-serif;
        border-collapse: collapse;
        border: 1px solid #ebebeb;
        margin: 10px auto;
        text-align: center;
        width: 100%;
        max-width: 500px;
      }
      .highcharts-data-table caption {
        padding: 1em 0;
        font-size: 1.2em;
        color: #555;
      }
      .highcharts-data-table th {
        font-weight: 600;
        padding: 0.5em;
      }
      .highcharts-data-table td,
      .highcharts-data-table th,
      .highcharts-data-table caption {
        padding: 0.5em;
      }
      .highcharts-data-table thead tr,
      .highcharts-data-table tr:nth-child(even) {
        background: #f8f8f8;
      }
      .highcharts-data-table tr:hover {
        background: #f1f7ff;
      }
    </style>
  </head>
  <body>
    <figure class="highcharts-figure">
      <div id="container"></div>
      <p class="highcharts-description">
        A basic column chart to show the highest number of times one player has
        been dismissed by another player
      </p>
    </figure>
    <script>
      // XMLHttpRequest to issue HTTP requests
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
          var response = JSON.parse(this.responseText);
          playerDismissalChart(response);
        }
      };
      xhttp.open("GET", "http://localhost:8000/playerDismissal", true);
      xhttp.send();
      // created a chart function which takes an object as a parameter
      function playerDismissalChart(obj) {
        let playerNameArr = Object.keys(obj);
        // series data is an array of objects.
        // Each object has 2 properties : one is name, whose value
        // is player name and another property is data whose value is an
        // array of number of dismissals by a bowler
        /* Example :
           seriesData = [
             {
               name : "2008"
               data : [5, 0, 0, 0, 0, 0, 0, 0, 0]
             }
           ]
        
        */
        let seriesData = playerNameArr.reduce(function(arr, player) {
          let playerObj = {};
          playerObj.name = obj[player]["bowlerName"];
          let dataArr = playerNameArr.reduce(function(arr, element) {
            if (player === element) {
              arr.push(obj[player]["dismissalCount"]);
            } else {
              arr.push(0);
            }
            return arr;
          }, []);
          playerObj.data = dataArr;
          arr.push(playerObj);
          return arr;
        }, []);
        Highcharts.chart("container", {
          chart: {
            type: "column"
          },
          title: {
            text:
              "Highest Number Of Times One Player Has Been Dismissed By Another Player"
          },
          xAxis: {
            categories: Object.keys(obj),
            crosshair: true
          },
          yAxis: {
            min: 0,
            title: {
              text: "Dismissal Count"
            }
          },
          series: seriesData
        });
      }
    </script>
  </body>
</html>
